﻿using System;
using System.IO;
using System.Reflection;
using System.Xml; 

using NLog;
using NLog.Config;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Assembly assembly = Assembly.GetExecutingAssembly(); 

            string resourceName = $"{typeof(Program).Namespace}.NLog.config"; 

            using(Stream stream = assembly.GetManifestResourceStream(resourceName))
            {
                using(XmlReader reader = XmlReader.Create(stream))
                {
                    LogManager.Configuration = new XmlLoggingConfiguration(reader, null);
                }
            } 
            
            Logger logger = LogManager.GetCurrentClassLogger(); 

            logger.Debug("DEBUG MESSAGE");

            logger.Warn("WARNING MESSAGE"); 

            logger.Error(new Exception("TEST ERROR"), "ERROR MESSAGE"); 

            logger.Fatal("FATAL MESSAGE");

            logger.Info("INFO MESSAGE"); 
        }

        #endregion
    }
}